#include "pr_state.h"
#include <QPen>

CL_STATE::CL_STATE( QGraphicsScene* pq_scene ):
    pq_scn(pq_scene)
{
    QPen pen;
    pen.setWidth(2);
    /*
    QPainterPath path;
    QBrush brush;
    */
    //add lines
    pq_line1 = pq_scn->addLine(0,0,0,0,pen);
    pq_line2 = pq_scn->addLine(0,0,0,0,pen);
    pq_line3 = pq_scn->addLine(this);
    pq_line4 = pq_scn->addLine(0,0,0,0,pen);
    //add arcs
    /*
    pq_arc1  = pq_scn->addPath(path,pen,brush);
    pq_arc2  = pq_scn->addPath(path,pen,brush);
    pq_arc3  = pq_scn->addPath(path,pen,brush);
    pq_arc4  = pq_scn->addPath(path,pen,brush);
    */
    //make movable
    pq_line1->setFlag(QGraphicsItem::ItemIsMovable);
    pq_line2->setFlag(QGraphicsItem::ItemIsMovable);
    pq_line3->setFlag(QGraphicsItem::ItemIsMovable);
    pq_line4->setFlag(QGraphicsItem::ItemIsMovable);
    pq_line1->setFlag(QGraphicsItem::ItemSendsGeometryChanges);
    pq_line2->setFlag(QGraphicsItem::ItemSendsGeometryChanges);
    pq_line3->setFlag(QGraphicsItem::ItemSendsGeometryChanges);
    pq_line4->setFlag(QGraphicsItem::ItemSendsGeometryChanges);

    //set move cursor
    pq_line1->setCursor(Qt::SizeAllCursor);
    pq_line2->setCursor(Qt::SizeAllCursor);
    pq_line3->setCursor(Qt::SizeAllCursor);
    pq_line4->setCursor(Qt::SizeAllCursor);
}

void CL_STATE::setPoint1(qreal x, qreal y)
{
    x1 = x;
    y1 = y;
    redraw();
}

void CL_STATE::setPoint2(qreal x, qreal y)
{
    x2 = x;
    y2 = y;
    redraw();
}

void CL_STATE::redraw()
{
    if(x1+50 <= x2 && y1+50 <= y2)
    {
        pq_line1->setLine(x1+20, y1   , x2-20, y1   );
        pq_line2->setLine(x2   , y1+20, x2   , y2-20);
        pq_line3->setLine(x2-20, y2   , x1+20, y2   );
        pq_line4->setLine(x1   , y2-20, x1   , y1+20);

        /*
        QPainterPath p1,p2,p3,p4;
        p1.arcMoveTo(x1   ,y1   ,40,40,  90); p1.arcTo(x1   ,y1   ,40,40,  90,90); pq_arc1->setPath(p1);
        p2.arcMoveTo(x2-40,y1   ,40,40,   0); p2.arcTo(x2-40,y1   ,40,40,   0,90); pq_arc2->setPath(p2);
        p3.arcMoveTo(x2-40,y2-40,40,40, -90); p3.arcTo(x2-40,y2-40,40,40, -90,90); pq_arc3->setPath(p3);
        p4.arcMoveTo(x1   ,y2-40,40,40,-180); p4.arcTo(x1   ,y2-40,40,40,-180,90); pq_arc4->setPath(p4);
        */
    }
    else
    {

    }
}

/*
QVariant QGraphicsLineItemMember::itemChange(GraphicsItemChange change, const QVariant &value)
{
    while(1);
    //return QGraphicsLineItem::itemChange(change, value);
}
*/
